Description

Currently, you can set a default spent time activity for all users, regardless their role.

| find it more useful if we add a default activity for each role (and not for each user how is requested in #938) because an user can
have different roles per projects. Maybe in one project I'm a developer and | want to have the "Development" activity as default, and
in another project I've the "Manager" role and | want to have the "Project Management" activity as default.

If a role doesn't have a default activity, the global should be set as default if exists, otherwise blank.

Any feedback is welcome.

Related issues:

Related to Redmine - Feature #938: Add default Activity value per user New 2008-03-27
Related to Redmine - Feature #7080: Alternate default activity in time logging New 2010-12-08
Related to Redmine - Feature #14983: Default Activity per Issue Tracker New
Related to Redmine - Feature #573: Spend time and Activity enhancement New

Associated revisions

Revision 21763 - 2022-08-09 04:50 - Go MAEDA
Add default spent time activity per role (#29286).

Patch by Marius BALTEANU and Mizuki ISHIKAWA.

Revision 21764 - 2022-08-09 04:56 - Go MAEDA
Update locales (#29286).

History

#1 - 2018-07-27 01:05 - Marius BALTEANU
- Related to Feature #938: Add default Activity value per user added

#2 - 2018-07-27 06:46 - Bernhard Rohloff

+1
This could really save time for many people and makes time tracking less tedious.

#3 - 2018-07-28 10:27 - 00 [

+1

#4 - 2018-08-07 06:33 - Marius BALTEANU
- Related to Feature #7080: Alternate default activity in time logging added

#5 - 2018-08-11 15:12 - Marius BALTEANU

- File 0001-Option-to-set-default-time-entry-activity-per-role.patch added
- File default_role_time_entry.png added

- Assignee deleted (Marius BALTEANU)

Attached is the patch that adds the option to define a default time entry activity for each role.
https://www.redmine.org/issues/938

default_role_time_entry.png
Any feedback is welcome.

#6 - 2018-09-09 02:45 - Go MAEDA

- Target version set to Candidate for next major release

#7 - 2018-11-25 08:36 - ciel ciel

| am using redmine 3.4.6. on bitnami, | apply the patch in the directory htdoc but once | redemare the service, access to the menu role hangs, | need
this feature and thank you

#8 - 2018-12-05 20:44 - Gerardo Schild

| am using redmine 3.4.6 on bitnami, although the patch did not work, | applied the changes manually and | had the following error, which should be
corrected for the patch

\app\models\time_entry_activity.rb

| get the error of: undefined function punk which solves it with .sort.map(&:default_time_entry_activity_id)

Thank you!

#9 - 2022-07-22 03:55 - Mizuki ISHIKAWA
- File 0001-Option-to-set-default-time-entry-activity-per-role-r21737.patch added

| think this feature very useful.
| have made changes so that | can apply the patch to the latest code.

Main Changes:

e Delete TimeEntryActivity.allowed_activities and replace with existing TimeEntryActivity.available_activities

e Integrate the code for selecting the existing default activity(
https://qgithub.com/redmine/redmine/blob/04e5ae033bf78d7cfd55dd1b905df79c2a913f83/app/models/time_entry.rb#L 110-L114 ) into
TimeEntryActivity.default_activity_id

e Add test for TimeEntryActivity.default_activity_id

¢ The change in
https:/github.com/redmine/redmine/commit/2fdbcd35dd8cc2{6b98340825a57afd24{f89670#diff-d94d27c8c3a5137bab78b034894d9febadabaac
9144c3177daaadbcieba6f02aR95 no longer sets the initial user, so the role for selecting the default activity is now taken from User.current (in
the patch, it was self.user, so it was no longer working).

e Member.find_or_new method is gone, replaced with Member.find_or_initialize_by.

#10 - 2022-08-02 04:19 - Go MAEDA

- Target version changed from Candidate for next major release to 5.1.0

Setting the target version to 5.1.0.

#11 - 2022-08-09 04:51 - Go MAEDA
- Status changed from New to Closed
- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch. Thank you all for your contribution.

#12 - 2023-04-16 16:21 - Go MAEDA
- Related to Feature #14983: Default Activity per Issue Tracker added

#13 - 2023-05-06 01:06 - Go MAEDA
- Related to Feature #573: Spend time and Activity enhancement added

Files

0001-Option-to-set-default-time-entry-activity-per-role.patch 9.76 KB 2018-08-11 Marius BALTEANU
default_role_time_entry.png 124 KB 2018-08-11 Marius BALTEANU
0001-Option-to-set-default-time-entry-activity-per-role-r21737.patch ~ 11.9 KB 2022-07-22 Mizuki ISHIKAWA
